export declare const RELATIVE_ARTICLES_DIR_PATH: string;
export declare const RELATIVE_EXTERNAL_RESOURCES_DIR_PATH: string;
export declare const PROJECT_ROOT: string;
export declare const PRESETS_EXTERNAL_RESOURCES_ROOT: string;
export declare const CONFIG_FILE_NAME = "ubw-configs.js";
export declare function toNormalizedAbsolutePath(pathInput: string, baseAbsolutePath: string): string;
/**
 * It is mainly used to normalize the following last case.
 *
 *   url="https://foo.com/bar"  -> pathname="/bar"
 *   url="https://foo.com/bar/" -> pathname="/bar/"
 *   url="https://foo.com/"     -> pathname="/"
 *   url="https://foo.com"      -> pathname="/" (What's!?)
 */
export declare function getPathnameWithoutTailingSlash(absoluteUrl: string): string;
export declare function permalinksToRelativeUrl(fromPermalink: string, toPermalink: string): string;
export declare function generateBlogPaths(blogRoot: string, relativePublicationDirPath: string): {
    sourceRoot: string;
    publicationRoot: string;
    sourceArticlesRoot: string;
    sourceExternalResourcesRoot: string;
    sourceExternalResourcesDirectPlacementRoot: string;
    publicationArticlesRoot: string;
    publicationExternalResourcesRoot: string;
    publicationExternalResourcesDirectPlacementRoot: string;
};
export declare function generateDateTimeString(date: Date, timeZone: string): string;
export declare function generateTodayDateString(date: Date, timeZone: string): string;
export interface RemarkAstNode {
    type: string;
    value?: string;
    depth?: number;
    children?: RemarkAstNode[];
}
export interface RehypeAstNode {
    type: string;
    tagName?: string;
    properties?: {
        ariaHidden?: boolean;
        className?: string[];
    };
    value?: string;
    children?: RehypeAstNode[];
}
export declare function scanRemarkAstNode(node: RemarkAstNode, callback: (node: RemarkAstNode) => void): void;
export declare function extractPageTitle(node: RemarkAstNode): string;
